<?php
/*
Simple:Press
Plupload plugin install/upgrade routine
$LastChangedDate: 2013-02-17 12:09:35 -0800 (Sun, 17 Feb 2013) $
$Rev: 9856 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_plupload_do_install() {
	$olduploads = sp_get_option('sfuploads');
	$uploads = sp_get_option('spPlupload');
	if (empty($olduploads) && empty($uploads)) {
        spdb_query('ALTER TABLE '.SFPOSTS.' ADD (attachments text)');

		$uploads = array();
		$uploads['showinserted'] = true;
    	$uploads['imageinsert'] = true;
		$uploads['imgquality'] = 100;
		$uploads['thumbquality'] = 100;
		$uploads['thumbsize'] = 80;
		$uploads['imagetypes'] = 'jpg, jpeg, gif, png';
		$uploads['imagemaxsize'] = 51200;
		$uploads['imagemaxwidth'] = 0;
		$uploads['imagemaxheight'] = 0;
    	$uploads['mediainsert'] = true;
		$uploads['mediatypes'] = 'swf, dcr, mov, qt, mpg, mp3, mp4, mpeg, avi, wmv, wm, asf, asx, wmx, wvx, rm, ra, ram';
		$uploads['mediamaxsize'] = 0;
		$uploads['mediawidth'] = 320;
		$uploads['mediaheight'] = 240;
		$uploads['filetypes'] = 'txt, rtf, doc, pdf';
		$uploads['filemaxsize'] = 51200;
		$uploads['prohibited'] = 'php, php3, php5, js, html, htm, phtml, asp, aspx, ascx, jsp, cfm, cfc, pl, bat, exe, dll, reg, cgi, sh, py';
        $uploads['useforphotos'] = false;
        $uploads['lang'] = 'en';

        $uploads['dbversion'] = SPPLUPDBVERSION;
		sp_add_option('spPlupload', $uploads);

		# storage location
		$perms = fileperms(SF_STORE_DIR);
		$owners = stat(SF_STORE_DIR);
		if($perms === false) $perms = 0755;
		$basepath = '';
		if (is_multisite()) {
            # construct multisite storage directory structure and create if necessary
            $basepath .= 'blogs.dir/'.SFBLOGID;
            if (!file_exists(SF_STORE_DIR.'/'.$basepath)) @mkdir(SF_STORE_DIR.'/'.$basepath, $perms);
            $basepath .= '/files';
            if (!file_exists(SF_STORE_DIR.'/'.$basepath)) @mkdir(SF_STORE_DIR.'/'.$basepath, $perms);
            $basepath .= '/';
        }

		$basepath .= 'sp-resources';
		if (!file_exists(SF_STORE_DIR.'/'.$basepath)) @mkdir(SF_STORE_DIR.'/'.$basepath, $perms);
		if (file_exists(SF_STORE_DIR.'/'.$basepath)) {
			# Is the ownership correct?
			$newowners = stat(SF_STORE_DIR.'/'.$basepath);
			if($newowners['uid']!=$owners['uid'] || $newowners['gid']!=$owners['gid']) {
				@chown(SF_STORE_DIR.'/'.$basepath, $owners['uid']);
				@chgrp(SF_STORE_DIR.'/'.$basepath, $owners['gid']);
			}
		}

		$sfconfig = sp_get_option('sfconfig');
		$sfconfig['image-uploads'] = $basepath.'/forum-image-uploads';
		$sfconfig['media-uploads'] = $basepath.'/forum-media-uploads';
		$sfconfig['file-uploads'] = $basepath.'/forum-file-uploads';
		sp_update_option('sfconfig', $sfconfig);

		$newpath = SF_STORE_DIR.'/'.$sfconfig['image-uploads'];
		@mkdir($newpath, 0777);

		$newpath = SF_STORE_DIR.'/'.$sfconfig['media-uploads'];
		@mkdir($newpath, 0777);

		$newpath = SF_STORE_DIR.'/'.$sfconfig['file-uploads'];
		@mkdir($newpath, 0777);
    } elseif (empty($uploads)) { # upgrade from pre sp 5.0 when pm was in core
        spdb_query('ALTER TABLE '.SFPOSTS.' ADD (attachments text)');

		$olduploads['showinserted'] = true;
    	$olduploads['imageinsert'] = true;
		$olduploads['imgquality'] = 100;
		$olduploads['thumbquality'] = 100;
		$olduploads['imagemaxwidth'] = 0;
		$olduploads['imagemaxheight'] = 0;
    	$olduploads['mediainsert'] = true;
		$olduploads['mediawidth'] = 320;
		$olduploads['mediaheight'] = 240;
        $olduploads['useforphotos'] = false;
        $olduploads['lang'] = 'en';
		sp_add_option('spPlupload', $olduploads);

		sp_delete_option('sfuploads');
    }

    # add a new permission into the auths table
	sp_add_auth('upload_images', __('Can upload images in posts', 'sp-plup'), 1, 1, 0, 0, 8);
	sp_add_auth('upload_media', __('Can upload media in posts', 'sp-plup'), 1, 1, 0, 0, 8);
	sp_add_auth('upload_files', __('Can upload files in posts', 'sp-plup'), 1, 1, 0, 0, 8);
	sp_add_auth('upload_signatures', __('Can upload signature images', 'sp-plup'), 1, 1, 0, 0, 8);
   	sp_add_auth('download_attachments', __('Can download other file type attachments', 'sp-plup'), 1, 0, 0, 0, 2);

    # activation so make our auth active
    sp_activate_auth('upload_images');
    sp_activate_auth('upload_media');
    sp_activate_auth('upload_files');
    sp_activate_auth('upload_signatures');
    sp_activate_auth('download_attachments');
}

# sp reactivated.
function sp_plupload_do_sp_activate() {
}

function sp_plupload_do_reset_permissions() {
	sp_add_auth('upload_images', __('Can upload images in posts', 'sp-plup'), 1, 1, 0, 0, 8);
	sp_add_auth('upload_media', __('Can upload media in posts', 'sp-plup'), 1, 1, 0, 0, 8);
	sp_add_auth('upload_files', __('Can upload files in posts', 'sp-plup'), 1, 1, 0, 0, 8);
	sp_add_auth('upload_signatures', __('Can upload signature images', 'sp-plup'), 1, 1, 0, 0, 8);
   	sp_add_auth('download_attachments', __('Can download other file type attachments', 'sp-plup'), 1, 0, 0, 0, 2);
}

?>