<?php
/*
Simple:Press
Plupload plugin install/upgrade routine
$LastChangedDate: 2013-02-17 12:09:35 -0800 (Sun, 17 Feb 2013) $
$Rev: 9856 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_plupload_do_upgrade_check() {
	$uploads = sp_get_option('spPlupload');
    if (empty($uploads)) return;

    $db = empty($uploads['dbversion']) ? 0 : $uploads['dbversion'];

    # quick bail check
    if ($db == SPPLUPDBVERSION ) return;

    # apply upgrades as needed

    # db version upgrades
    if ($db < 1) {
        # add a new permission into the auths table
    	sp_add_auth('download_attachments', __('Can download other file type attachments', 'sp-plup'), 1, 0, 0, 0, 2);
        $uploads['lang'] = 'en';
        $uploads['useforphotos'] = false;
    }

    if ($db < 2) {
        # download other file attachments should not ignore guests
        spdb_query('UPDATE '.SFAUTHS.' SET ignored = 0 WHERE auth_name = "download_attachments"');
    }

    if ($db < 3) {
	   spdb_query('UPDATE '.SFAUTHS." SET auth_cat=8 WHERE auth_name='upload_images'");
	   spdb_query('UPDATE '.SFAUTHS." SET auth_cat=8 WHERE auth_name='upload_media'");
	   spdb_query('UPDATE '.SFAUTHS." SET auth_cat=8 WHERE auth_name='upload_files'");
	   spdb_query('UPDATE '.SFAUTHS." SET auth_cat=8 WHERE auth_name='upload_signatures'");
	   spdb_query('UPDATE '.SFAUTHS." SET auth_cat=1 WHERE auth_name='download_attachments'");
    }

    # save data
    $uploads['dbversion'] = SPPLUPDBVERSION;
    sp_update_option('spPlupload', $uploads);
}

?>